#define VERSION "1.02"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/dos.h>

int Data_Out( unsigned char * , unsigned short );
int Data_In( unsigned char * , unsigned short );
void Initialize_Outport( int );
void vsync( void );

void wait( int n )
{
	int i;

	for ( i = 0; i < n; i++ )
		vsync();
}

int get_extension( char *buf, char *filename )
{
	char *p;
	int i;

	i = 0;
	p = filename + strlen(filename) - 1;
	while ( *p != '.' ) {
		buf[i++] = *(p--);
		if ( p - filename < 0 ) return -1;		/* gq݂͑Ȃ */
	}

	buf[i] = '\0';
	strrev(buf);
	return 0;
}

void add_extension( char *buf, char *filename, char *ext )
{
	char e[32];

	strcpy(buf,filename);

	if ( get_extension(e,buf) == 0 ) return;	/* gq݂͑ */

	strcat(buf,ext);
}

/* f[^o */
void output_data( char **file, int n )
{
	FILE *fp;
	unsigned char *p;
	int len,i;
	char filename[256];

	for ( i = 0; i < n; i++ ) {

		add_extension(filename,file[i],".rmt");

		if (( fp = fopen(filename,"rb")) == NULL ) {
			puts("error:Can't open inputfile.");
			exit(1);
		}

		len = filelength(fileno(fp));
		if (( p = malloc(len)) == NULL ) {
			puts("error:No enough memory.");
			exit(1);
		}

		fread(p,1,len,fp);
		fclose(fp);

		if ( Data_Out(p,len) ) {
			puts("error:TIMER-DłɎgpĂ܂D");
			exit(1);
		}

		free(p);
		wait(20);
	}

	Initialize_Outport(9);
}

/* f[^ */
void input_data( char *file )
{
	FILE *fp;
	int len;
	unsigned char *p;
	char filename[256];

	add_extension(filename,file,".rmt");

	if (( fp = fopen(filename,"wb")) == NULL ) {
		puts("error:Can't open outputfile.");
		exit(1);
	}

	len = 65535;
	if (( p = malloc(len)) == NULL ) {
		puts("error:No enough memory.");
		exit(1);
	}

	_dos_c_curoff();
	puts("Now waiting for infrared rays...");

	if ( Data_In(p,len) ) {
		puts("error:TIMER-DłɎgpĂ܂D");
		exit(1);
	}

	fwrite(p,1,len,fp);
	fclose(fp);
	free(p);
	Initialize_Outport(9);

	_dos_c_curon();
	puts("completed.");
}

void rmt_to_p16( char *file1, char *file2 )
{
	FILE *fp;
	int i,len;
	char *p,filename[256];
	short *q;

	add_extension(filename,file1,".rmt");

	if ((fp = fopen(filename,"rb")) == NULL ) {
		puts("error:Can't open inputfile.");
		exit(1);
	}

	len = filelength(fileno(fp));
	if ((p = malloc(len)) == NULL ) {
		puts("error:No enough memory.");
		fcloseall();
		exit(1);
	}
	if ((q = malloc(2*len)) == NULL ) {
		puts("error:No enough memory.");
		fcloseall();
		exit(1);
	}

	fread(p,1,len,fp);
	fclose(fp);

	for ( i = 0; i < len; i++ ) {
		if ( p[i] == 8 )
			q[i] = 0x1000;
		else if ( p[i] == 9 )
			q[i] = 0x0000;
		else {
			puts("error:Unknown format.");
			exit(1);
		}
	}

	add_extension(filename,file2,".p16");

	if ((fp = fopen(filename,"wb")) == NULL ) {
		puts("error:Can't open outputfile.");
		exit(1);
	}

	fwrite(q,2,len,fp);
	fclose(fp);

	free(p);
	free(q);
}

void p16_to_rmt( char *file1, char *file2 )
{
	FILE *fp;
	int i,len;
	char *p,filename[256];
	short *q;

	add_extension(filename,file1,".p16");

	if ((fp = fopen(filename,"rb")) == NULL ) {
		puts("error:Can't open inputfile.");
		exit(1);
	}

	len = filelength(fileno(fp))/2;
	if ((q = malloc(len*2)) == NULL ) {
		puts("error:No enough memory.");
		fcloseall();
		exit(1);
	}
	if ((p = malloc(len)) == NULL ) {
		puts("error:No enough memory.");
		fcloseall();
		exit(1);
	}

	fread(q,2,len,fp);
	fclose(fp);

	for ( i = 0; i < len; i++ ) {
		if ( q[i] == 0x1000 )
			p[i] = 8;
		else if ( q[i] == 0x0000 )
			p[i] = 9;
		else {
			puts("error:Unknown format.");
			exit(1);
		}
	}

	add_extension(filename,file2,".rmt");

	if ((fp = fopen(filename,"wb")) == NULL ) {
		puts("error:Can't open outputfile.");
		exit(1);
	}

	fwrite(p,1,len,fp);
	fclose(fp);

	free(p);
	free(q);
}

int main( int argc, char **argv )
{
	if ( argc == 1 ) {
		HELP:;
		puts("\x1b[37mUniversal Remote Controller\x1b[m remote.x ver"VERSION" 1995 by appyo");
		puts(" usage: remote [-p|-r|-e|-d] <filename> [<filename>..]");
		puts("option: -p ... output mode(default)");
		puts("        -r ... recoding mode");
		puts("        -e ... rmt to p16");
		puts("        -d ... p16 to rmt");
		puts("        -i ... initialize outport");
		exit(1);
	}

	if ( argv[1][0] == '-' ) {
		switch ( argv[1][1] ) {
		case 'p':
			if ( argc < 3 ) goto HELP;
			output_data(argv+2,argc-2);
			break;
		case 'r':
			if ( argc < 3 ) goto HELP;
			input_data(argv[2]);
			break;
		case 'e':
			if ( argc < 4 ) goto HELP;
			rmt_to_p16(argv[2],argv[3]);
			break;
		case 'd':
			if ( argc < 4 ) goto HELP;
			p16_to_rmt(argv[2],argv[3]);
			break;
		case 'i':
			Initialize_Outport(8);
			break;
		default:
			goto HELP;
		}
	} else {
		output_data(argv+1,argc-1);
	}

	exit(0);
}
